﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DrugiKolokvijum
{
    public class Student:IComparable<Student>,IEquatable<Student>
    {
        int indeks;
        public int Indeks { get { return indeks; } }

        int godinaUpisa;
        public int GodinaUpisa { get { return godinaUpisa; } }

        string imeIPrezime;
        public string ImeIPrezime { get { return imeIPrezime; } }

        DateTime datumRodjenja;
        public DateTime DatumRodjenja { get { return datumRodjenja; } }

        double brojPoena;
        public double BrojPoena { get { return brojPoena; } set { brojPoena = value; } }

        public Student(int indeks, int godina, string imePrez, DateTime datum) {
            this.indeks = indeks;
            this.godinaUpisa = godina;
            this.imeIPrezime = imePrez;
            this.datumRodjenja = datum;
        }

        public override string ToString()
        {
            return  ImeIPrezime + " : " + DatumRodjenja + ", " + Indeks + "/" + GodinaUpisa + ", broj poena=" + BrojPoena;
        }

        public int CompareTo(Student other)
        {
            if (this.brojPoena > other.brojPoena)
                return 1;
            else if (this.brojPoena == other.brojPoena)
                return 0;
            else return -1;
        }

        public bool Equals(Student other)
        {
            if (this.brojPoena == other.brojPoena)
                return true;
            return false;
        }
    }
}
