﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Filip_Radovanovic_73_12
{
    public delegate bool Selektuj<T>(T item);

    public class BinarnoStablo<T> where T : IComparable<T>
    {
        private Cvor<T> glava = null;

        public void dodajVrednost(T item)
        {
            if (glava == null)
            {
                glava = new Cvor<T>(item);
                return;
            }

            Cvor<T> pom = glava;
            Cvor<T> pom2 = null;

            while (pom != null)
            {
                pom2 = pom;
                if (pom.Vrednost.CompareTo(item) < 0)
                    pom = pom.levi;
                else
                    pom = pom.desni;
            }

            if (pom2.Vrednost.CompareTo(item) < 0)
            {
                pom2.levi = new Cvor<T>(item);
            }
            else
                {
                    pom2.desni = new Cvor<T>(item);
                }
        }

        public T this[int index]
        {
            get
            {
                T vrednost = default(T);
                int i = 0;

                foreach(T item in dajEnumerator())
                {
                    if (i == index)
                        return item;

                    i++;
                }

                return vrednost;
            }

        }

        public IEnumerable<T> VratiEnumeratorPremaSelekciji(Selektuj<T> uslov)
        {
            List<T> lista = new List<T>();

            prodjiKrozStablo(lista, this.glava);

            foreach (T item in lista)
            {
                if(uslov(item))
                    yield return item;
            }
        }

        private IEnumerable<T> dajEnumerator()
        {
            List<T> lista = new List<T>();

            prodjiKrozStablo(lista, glava);

            foreach (T item in lista)
            {
                 yield return item;
            }
        }

        private void prodjiKrozStablo(List<T> lista, Cvor<T> pom)
        {
            if (pom != null)
            {
                prodjiKrozStablo(lista, pom.levi);

                lista.Add(pom.Vrednost);

                prodjiKrozStablo(lista, pom.desni);
            }
        }
    }
}
