﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace drugiPopravni
{
    public class BinarnoStablo<T> where T:IComparable<T>
    {
        Cvor<T> glava;
        List<T> lista;
        
        public BinarnoStablo()
        {
            glava=null;
            lista = new List<T>();
            
        }

        public void dodajVrednost(T podatak)
        {
            if (glava == null)
            {
                glava = new Cvor<T>(podatak);
            }
            else
            {
                Cvor<T> pom = glava;
                Cvor<T> prethodni=null;
                while(pom!=null)
                    if (pom.Vrednost.CompareTo(podatak) == 1)
                    {
                        prethodni = pom;
                        pom = pom.levi;
                    }
                    else
                    {
                        prethodni = pom;
                        pom = pom.desni;
                    }
                if (prethodni.Vrednost.CompareTo(podatak) == 1)
                    prethodni.levi = new Cvor<T>(podatak);
                else
                    prethodni.desni = new Cvor<T>(podatak);
            }
            lista.Clear();
            ucitajStabloUListu(glava);
        }

       
        private void ucitajStabloUListu(Cvor<T> p)
        {
            if (p!=null)
            {
                ucitajStabloUListu(p.levi);
                lista.Add(p.Vrednost);
                ucitajStabloUListu(p.desni);
            }
        }


        public IEnumerable<T> vratiEnumeratorPremaSelekciji(Selektuj<T> uslov)
        {
            foreach (T podatak in lista)
                if (uslov(podatak))
                    yield return podatak;
        }

        public T this[int n]
        {
            get
            {
                return lista[n];
            }
        }

        public int Count
        {
            get
            {
                return lista.Count();
            }
        }
    }
}
