﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace drugiPopravni
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        BinarnoStablo<Student> stablo;
        List<Student> dodati;
        public MainWindow()
        {
            InitializeComponent();
            dodati=new List<Student>();
            stablo=new BinarnoStablo<Student>();
        }

        private void btnDodaj_Click(object sender, RoutedEventArgs e)
        {
            int index,upisan,brPoena;
            try
            {
                if (txtIme.Text != "" && int.TryParse(txtIndex.Text, out index) && int.TryParse(txtUpisan.Text, out upisan) && int.TryParse(txtPoeni.Text, out brPoena))
                {
                    Student s = new Student(index, upisan, txtIme.Text, dpRodjen.SelectedDate.Value);
                    s.BrojPoena = brPoena;
                    if (!dodati.Contains(s))
                    {
                        stablo.dodajVrednost(s);
                        dodati.Add(s);
                        lbStudenti.Items.Clear();
                        int br=stablo.Count;
                        for (int i = 0; i < br; i++)
                            lbStudenti.Items.Add(stablo[i].ToString());
                    }
                }
                else
                {
                    MessageBox.Show("Unesite sve potrebne parametre!");

                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Unesite sve potrebne parametre!");
            }
        }

        private void btnPrikazi_Click(object sender, RoutedEventArgs e)
        {
            if (cbUslov.SelectedIndex == 0)
            {
                int max;
                if(int.TryParse(txtMax.Text,out max))
                {
                    IEnumerable<Student> svi = stablo.vratiEnumeratorPremaSelekciji(x => (x.BrojPoena >= ((double)max / 2)));
                    lbSelekcija.Items.Clear();
                    foreach (Student s in svi)
                        lbSelekcija.Items.Add(s.ToString());
                }
                else
                    MessageBox.Show("Unesite maximalan broj");
            }
            else if (cbUslov.SelectedIndex == 1)
            {
                int max;
                if (int.TryParse(txtMax.Text, out max))
                {
                    IEnumerable<Student> svi = stablo.vratiEnumeratorPremaSelekciji(x => ((x.BrojPoena < (double)max / 2) && (x.DatumRodjenja.Year==1991 || x.DatumRodjenja.Year==1990)));
                    lbSelekcija.Items.Clear();
                    List<Student> pomocna = new List<Student>();
                    foreach (Student s in svi)
                        pomocna.Add(s);
                    for (int i = (pomocna.Count - 1); i >= 0; i--)
                        lbSelekcija.Items.Add(pomocna[i].ToString());
                }
                else
                    MessageBox.Show("Unesite maximalan broj");
            }
            else
                MessageBox.Show("Odaberite uslov u combo boxu!");
        }

        private void btnPrikaz_Click(object sender, RoutedEventArgs e)
        {
            int rb;
            if (int.TryParse(txtRedni.Text, out rb))
            {
                if (rb <= stablo.Count && rb>0)
                    txtStudent.Content = stablo[rb-1].ToString();
                else
                    MessageBox.Show("Nema toliko studenata!");
            }
            else
                MessageBox.Show("Unesite broj za redni broj studneta!");
        }
    }
}
