﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace prviPopravni
{
    public class Putovanje:IPopust
    {
        private string pocetnaDestinacija;
        private string krajnjaDestinacija;
        protected List<Aranzman> aranzmani;

        public Putovanje(string poc, string kraj)
        {
            this.pocetnaDestinacija = poc;
            this.krajnjaDestinacija = kraj;
        }

        public void dodajAranzman(List<Aranzman> a)
        {
            if (a[0].PocetnaDestinacija != pocetnaDestinacija)
                throw new GreskaPutovanja(a[0], "pocetna destinacija aranzmana i pocetna destinacija putovanja se ne slazu!");
            if (a[a.Count-1].KrajnjaDestinacija != pocetnaDestinacija)
                throw new GreskaPutovanja(a[a.Count-1], "krajnja destinacija aranzmana i pocetna destinacija putovanja se ne slazu!");
            aranzmani = a;
        }

        public double CenaPutovanja
        {
            get
            {
                double cena=0;
                foreach (Aranzman a in aranzmani)
                    cena += a.CenaAranzmana;
                return cena;
            }
        }

        public double Popust
        {
            get
            {
                double cena = 0;
                foreach (Aranzman a in aranzmani)
                    cena += a.Popust;
                return cena;
            }
        }
        public override string ToString()
        {
            string s="Putovanje: "+pocetnaDestinacija+" -> " +krajnjaDestinacija + "\n";
            foreach (Aranzman a in aranzmani)
                s += a.ToString() + "\n";
            return s;
        }
    }
}
