﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PrviKolokvijum
{
    public class Aranzman : IPopust
    {
        private string pocetnaDestinacija;
        private string krajnjaDestinacija;
        private bool lastMinute;
        private int brojNocenja;
        private double cenaNocenja;
        private List<Karta> karte;

        public string PocetnaDestinacija { get { return pocetnaDestinacija; } }
        public string KrajnjaDestinacija { get { return krajnjaDestinacija; } }

        public Aranzman(string pocetna, string krajnja, bool lastMinute, int brojNocenja, double cenaNocenja)
        {
            this.pocetnaDestinacija = pocetna;
            this.krajnjaDestinacija = krajnja;
            this.lastMinute = lastMinute;
            this.brojNocenja = brojNocenja;
            this.cenaNocenja = cenaNocenja;
            karte = new List<Karta>();
        }

        public void dodajKarte(List<Karta> k)
        {

            Karta pocetna = k.First<Karta>();
            Karta krajnja = k.Last<Karta>();
            foreach (Karta item in k)
            {
                try
                {
                    if (!pocetna.PocetnaDestinacija.Equals(this.PocetnaDestinacija))
                    {
                        karte.Add(item);
                    }
                    else
                        try
                        {
                            throw new GreskaAranzmana(item, "Pocetna destinacija nije ista!");
                        }
                        catch
                        {
                        }
                }
                catch (GreskaAranzmana ga)
                {

                    Console.WriteLine(ga.ToString());
                }

                try
                {
                    if (!krajnja.KrajnjaDestinacija.Equals(this.KrajnjaDestinacija))
                    {
                        karte.Add(item);
                    }
                    else
                        try
                        {
                            throw new GreskaAranzmana(item, "Krajnja destinacija nije ista!");
                        }
                        catch
                        {
                        }
                }
                catch (GreskaAranzmana ga)
                {
                    Console.WriteLine(ga.ToString());
                }
               /*
                    if (pocetna.PocetnaDestinacija.Equals(this.PocetnaDestinacija))
                    {
                        
                    }
                    else
                        throw new GreskaAranzmana(item, "Pocetna destinacija nije ista!");
                
                    if (krajnja.KrajnjaDestinacija.Equals(this.KrajnjaDestinacija))
                    {
                        
                    }
                    else
                        throw new GreskaAranzmana(item, "Krajnja destinacija nije ista!");
                
                if(item != null)
                    karte.Add(item);*/
            }
        }

        public double CenaAranzmana
        {
            get
            {
                double cena = cenaNocenja * brojNocenja;

                foreach (Karta item in karte)
                {
                    cena += item.dajCenuKarte();
                }

                return cena;
            }
        }

        public double Popust
        {
            get 
            {
                double popust = 0;

                foreach (Karta item in karte)
                {
                    if (item is IPopust)
                        popust += ((IPopust)item).Popust;
                }

                double novaCenaNocenja = 0;
                if (lastMinute)
                    novaCenaNocenja = 0.7 * this.cenaNocenja;

                popust += novaCenaNocenja;

                return popust;
            }
        }

        public override string ToString()
        {
            string poruka = "Aranzman:" + PocetnaDestinacija + "-" + KrajnjaDestinacija+"\n";

            foreach (Karta item in karte)
            {
                poruka += item.ToString() + "\n";
            }

            return poruka;
        }
    }
}
