﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        DataClassesDataContext data;
        public MainWindow()
        {
            InitializeComponent();
            data = new DataClassesDataContext();
            pokrenirezultate();
        }

        private void pokrenirezultate()
        {
            double[] datumi=new double[100];
            DateTime date=DateTime.Now;
            
            var da = from ut in data.Utakmicas 
                     select ut;
            int j=0;
            foreach (var item in da)
	        {
                datumi[j++] = (date.Subtract(item.PocetakUtakmice).Minutes);
	        }

            
            var utakmice = from s in data.Utakmicas
                    join e in data.Ekipas
                    on s.IDEkipeDomacina equals e.ID
                    join el in data.Ekipas
                    on s.IDEkipeGosta equals el.ID
                    select new{Domacin=e.Naziv,Gost=el.Naziv,Minut=date.Subtract(s.PocetakUtakmice).Minutes};

            string[] vremena=new string[100];
            int b=0;
            foreach (var item in utakmice)
            {
                if(item.Minut<0)
                {
                    vremena[b++]="Utakmica nije pocela";
                }
                else if(item.Minut>45 && item.Minut<60)
                {
                    vremena[b++]="poluvreme";
                }
                else if(item.Minut>=60)
                {
                    int vreme=item.Minut-15;
                    vremena[b++]=""+vreme;
                }
                else vremena[b++]=""+item.Minut;
            }
     
            int gh=0;
            foreach (var item in utakmice)
            {
                var novi=new {Domacin=item.Domacin,Gost=item.Gost,Rezultat="1",Minut=vremena[gh++]};
                listView1.Items.Add(novi);
            }

        }

        private void buttonosvezi_Click(object sender, RoutedEventArgs e)
        {
            listView1.Items.Clear();
            pokrenirezultate();
        }

        private void listView1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            var element = listView1.SelectedItem as Utakmica;
           // if (element != null)
            {
                Window1 forma = new Window1();
                forma.Show();
            }
        }

        

        private void MenuItem_Click(object sender, RoutedEventArgs e)
        {
            Window2 foma = new Window2();
            foma.Show();
        }

        private void MenuItem_Click_1(object sender, RoutedEventArgs e)
        {
            this.Close();
        }
    }
}
