﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        DataClassesDataContext data;
        public Window1(int id1,int id2)
        {
            InitializeComponent();
            data = new DataClassesDataContext();
        }

        public Window1()
        {
            InitializeComponent();
            data = new DataClassesDataContext();
            var cmb = from si in data.Ekipas
                      select si;
            comboBox1.ItemsSource = cmb;
        }

        private void comboBox1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            var selection = comboBox1.SelectedItem as Ekipa;
            var cmb = from si in data.Igracs
                      where si.ID==selection.ID
                      select si;
            comboBox2.ItemsSource = cmb;
        }

        private void Dodaj_Click(object sender, RoutedEventArgs e)
        {
            if (comboBox1.SelectedValue != null && comboBox2.SelectedValue != null)
            {
                var ekupa = comboBox1.SelectedItem as Ekipa;
                var igrac = comboBox2.SelectedItem as Igrac;
                var idutakmice = from s in data.Ekipas
                             join ut in data.Utakmicas
                             on s.ID equals ut.IDEkipeDomacina
                             join uta in data.Utakmicas
                             on s.ID equals uta.IDEkipeGosta
                             join igraci in data.Igracs
                             on s.ID equals igraci.IDEkipe
                             where ekupa.ID == ut.IDEkipeDomacina || ekupa.ID == ut.IDEkipeGosta
                                 select new Gol { IDUtakmice = ut.ID, IDIgraca = igraci.ID, IDEkipe = igraci.IDEkipe, VremeGola = DateTime.Now };

                var tekma = idutakmice.FirstOrDefault();
                data.Gols.InsertOnSubmit(tekma);
                data.SubmitChanges();
            }
        }
    }
}
