﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PrviKol
{
    public class Aranzman : IPopust
    {
        private string pocetanaDestinacija;


        private string krajnjadestinacija;

        
        private bool lastMinute;
        private int brojNocenja;
        private double cenaNocenja;
        protected List<Karta> listaKarata;

        public string PocetanaDestinacija
        {
            get { return pocetanaDestinacija; }
            
        }
        public string Krajnjadestinacija
        {
            get { return krajnjadestinacija; }
            
        }
        public Aranzman(string pocetanaDestinacija, string krajnjaDest, 
            int brojNocenja, double cenaNoc,bool lastMin)
        {
            this.pocetanaDestinacija = pocetanaDestinacija;
            this.krajnjadestinacija = krajnjaDest;
            this.lastMinute = lastMin;
            this.brojNocenja = brojNocenja;
            this.cenaNocenja = cenaNoc;
            
        }
        public void dodajKarte(List<Karta> listaKarata)
        {

            if (listaKarata.First().PocetnaDestinacija != pocetanaDestinacija)
                throw new GreskaAranzmana(listaKarata.First(), "pocetne destinacije se ne poklapaju");
            else if (listaKarata.Last().KrajnjaDestinacija != krajnjadestinacija)
                throw new GreskaAranzmana(listaKarata.Last(), "kranje destinacije se ne poklapaju");
            else
            {
                this.listaKarata = listaKarata;
            }
        }
        public double CenaAranzmana
        {
            get
            {
                double cena;
                cena = brojNocenja * cenaNocenja;
                foreach (Karta k in listaKarata)
                {
                    cena += k.dajCenuKarte();
                }
                return cena;
            }
        }

        public double Popust
        {
            get 
            {
                IPopust ip;
                double popust = cenaNocenja * 0.3;
                foreach (Karta k in listaKarata)
                {
                    ip = k as IPopust;
                    if (ip != null)
                    {
                        popust += ip.Popust;
                    }
                }
                return popust;
            }
        }
        public override string ToString()
        {
            string s = "";
            s += "Aranzman:" + pocetanaDestinacija + "-" + krajnjadestinacija;
            foreach (Karta k in listaKarata)
            {
                s += "\n" + k.ToString();
            }
            return s;
        }
    }
}
