﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace TreciKol
{
    /// <summary>
    /// Interaction logic for DodavanjeGolova.xaml
    /// </summary>
    public partial class DodavanjeGolova : Window
    {
        RezultatiDataContext rdc;
        int IDUtakmice;
        bool ind;
        public DodavanjeGolova(RezultatiDataContext rdc,int IDutakmice)
        {
            InitializeComponent();
            this.rdc = rdc;
            this.IDUtakmice = IDutakmice;
            var utakmice = from u in rdc.Utakmicas
                           where IDutakmice == u.ID
                           select u.PocetakUtakmice;
            if( kojeJeVreme(utakmice.First(),DateTime.Now) == "mec nije poceo")
            
                this.ind = false;
            else
                this.ind = true;
            pupuniVrednosti();
        }
        string kojeJeVreme(DateTime pocetak, DateTime trenutnoVreme)
        {
            string s = "";
            double razlika = (trenutnoVreme.Subtract(pocetak)).TotalMinutes;
            if (razlika < 0)
                s = "mec nije poceo";
            else if (razlika > 45 && razlika < 60)
                s = "poluvreme";
            else if (razlika >= 60 && razlika <= 90)
            {
                razlika -= 15;
                s = (int)razlika + "'";
            }
            else if (razlika > 0 && razlika <= 45)
                s = (int)razlika + "'";
            else if (razlika > 90)
                s = "kraj";
            return s;
        }

        private void pupuniVrednosti()
        {
            if (!ind)
            {
                cmbDodaj.IsEnabled = false;
                cmbIgrac.IsEnabled = false;
                cmbTim.IsEnabled = false;
                return;
            }
            else
            {
                var domaci = from u in rdc.Utakmicas
                             where IDUtakmice == u.ID
                             join e in rdc.Ekipas
                             on u.IDEkipeDomacina equals e.ID
                             select e;
                cmbTim.ItemsSource = domaci;
                var gosti = from u in rdc.Utakmicas
                            where IDUtakmice == u.ID
                            join e in rdc.Ekipas
                            on u.IDEkipeGosta equals e.ID
                            select e;
                cmbTim.ItemsSource = gosti;
                cmbTim.SelectedIndex = 0;
              }


        }

        private void cmbDodaj_Click(object sender, RoutedEventArgs e)
        {
            Gol gol = new Gol();
            Igrac i = cmbIgrac.SelectedItem as Igrac;
            Ekipa ekipa = cmbTim.SelectedItem as Ekipa;
            gol.IDIgraca = i.ID;
            gol.IDUtakmice = IDUtakmice;
            gol.IDEkipe = ekipa.ID;
            gol.VremeGola = DateTime.Now;
            rdc.Gols.InsertOnSubmit(gol);
            rdc.SubmitChanges();

        }

        private void cmbTim_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            popuniIgrace();

        }

        private void popuniIgrace()
        {
            Ekipa e = cmbTim.SelectedItem as Ekipa;
            if(e != null)
            {
                var igraci = from i in rdc.Igracs
                             where i.IDEkipe == e.ID
                             select i;
                cmbIgrac.ItemsSource = igraci;
            }
            
        }

    }
}
