﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;

namespace II_popravni
{
    public class BinarnoStablo<T> where T : IComparable<T>
    {
        Cvor<T> glava;


        public void DodajVrednost(T vrednost)
        {
            Cvor<T> novi = new Cvor<T>(vrednost);
            novi.Levi = null;
            novi.Desni = null;

            Cvor<T> pomocni;
            Cvor<T> prethodni;

            if (glava == null)
            {
                glava = novi;
                glava.Desni = null;
                glava.Levi = null;
            }
            else
            {
                prethodni = null;
                pomocni = glava;
                while (pomocni != null)
                {
                    if (novi.CompareTo(pomocni) == 1)
                    {
                        prethodni = pomocni;
                        pomocni = pomocni.Desni;
                    }
                    else
                    {
                        prethodni = pomocni;
                        pomocni = pomocni.Levi;
                    }

                }

                if (novi.CompareTo(prethodni) == 1)
                {
                    prethodni.Desni = novi;
                }
                else
                {
                    prethodni.Levi = novi;
                }
            }
        }

       /* public IEnumerable<T> VratiEnumeratorPremaSelekciji(Selektuj<T> selekcija,T vrednost)
        {
            
        }*/


        public IEnumerator<Cvor<T>> GetEnumerator()
        {
            foreach (Cvor<T> cvor in this)
            {
                yield return cvor;
            }
        }

        public string StampajCvor(Cvor<T> cvor)
        {
            return cvor.Vrednost.ToString();
        }

        public void StampajStablo(Cvor<T> glava)
        {
            if (glava == null)
            {
                return;
            }
            else
            {
                StampajStablo(glava.Levi);
                this.StampajCvor(this.glava);
                StampajStablo(glava.Desni);
            }
        }

        public Cvor<T> VratiNti(Cvor<T> glava,int n)
        {
            if (n == -1)
            {
                return null;
            }
            else
            {
                VratiNti(glava.Levi, n - 1);
                return glava;
            }
        }
    
        public Cvor<T> this[int index]
        {
            get 
            {
                return VratiNti(this.glava, index);
            }
            
        }
    }
}
