﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace II_popravni
{

    public delegate bool Selektuj<T>(T arg);
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        List<Student> studenti;
        BinarnoStablo<Student> stablo;
        //Cvor<Student> studentCvor;

        public MainWindow()
        {
            InitializeComponent();
            studenti = new List<Student>();
            stablo = new BinarnoStablo<Student>();
        }

        private void btnDodaj_Click(object sender, RoutedEventArgs e)
        {
            //PROVERAVANJEUNOSA
            if (txtIme.Text == " " || txtIndeks.Text == " " || txtGodina.Text == " " || txtBrPoena.Text == " " || datePicker1.SelectedDate == null)
            {
                MessageBox.Show("Morate popuniti sva polja!");
                txtIme.Focus();
            }
            else
            {
                int indeks = int.Parse(txtIndeks.Text);
                int godina = int.Parse(txtGodina.Text);
                string ime = txtIme.Text;
                DateTime datum = (DateTime)datePicker1.SelectedDate;
                double poeni = double.Parse(txtBrPoena.Text);

                Student student = new Student(indeks, godina, ime, datum, poeni);


                bool postoji = false;
                foreach (Cvor<Student> cvor in stablo)
                {
                    if (cvor.Vrednost.Indeks == student.Indeks && cvor.Vrednost.GodinaUpisa == student.GodinaUpisa)
                    {
                        postoji = true;
                    }
                }



                if (postoji)
                {
                    MessageBox.Show("Ovaj student je vec unet!");
                }
                else
                {
                    //studenti.Add(student);
                    // studentCvor = new Cvor<Student>(student);
                    stablo.DodajVrednost(student);
                    //lstbStudenti.Items.Add(student);
                    Osvezi();
                }

                foreach (Cvor<Student> cvor in stablo)
                {
                    lstbStudenti.Items.Add(cvor.Vrednost.ToString());
                }
            }   
            
        }

        private void Osvezi()
        {

            txtIme.Text = " ";
            txtIndeks.Text = " ";
            txtGodina.Text = " ";
            txtBrPoena.Text = " ";
            datePicker1.SelectedDate = null;  
        }
    }
}
