﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace III_popravni
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        RezultatiDataContext dc;

        public MainWindow()
        {
            InitializeComponent();
            dc = new RezultatiDataContext();
            ListajTekme();
            
        }

        private void ListajTekme()
        {
            DateTime trenutnoVreme;
            trenutnoVreme = DateTime.Now;

            var utakmice = from ut in dc.Utakmicas
                           join e in dc.Ekipas
                           on ut.IDEkipeDomacina equals e.ID
                           join ek in dc.Ekipas
                           on ut.IDEkipeGosta equals ek.ID
                           select new { ut.ID, ut.IDEkipeDomacina, ut.IDEkipeGosta, Domacin = e.Naziv, Gost = ek.Naziv, ut.PocetakUtakmice, ut.KrajUtakmice, minut = trenutnoVreme.Subtract(ut.PocetakUtakmice).TotalMinutes };
                           



            
            string minuti;
            foreach (var tekma in utakmice)
            {
                if (tekma.minut < 0)
                {
                    minuti = "Nije pocela";
                }
                else if (tekma.minut < 60 && tekma.minut > 45)
	            {
                    minuti = "poluvreme";
	            }
                else if (tekma.minut >= 60)
	            {
                    if (tekma.minut > 105)
                    {
                        minuti = "Utakmica je zavrsena!";
                    }
                    else
                    {
                        double min = tekma.minut - 15;
                        minuti = "Igra se " + min + ". minut"; 
                    }
                    
	            }
                else
                {
                    double min = tekma.minut;
                    minuti = "Igra se " + min + ". minut"; 
                }

                if (minuti != "Utakmica je zavrsena!")
                {
                    var nova = new { Domacin = tekma.Domacin, Gost = tekma.Gost, minuti = minuti };
                    lstvTekme.Items.Add(nova);
                } 
            }

        }

        private void btnOsvezi_Click(object sender, RoutedEventArgs e)
        {
            lstvTekme.Items.Clear();

            DateTime trenutnoVreme;
            trenutnoVreme = DateTime.Now;

            var utakmice = from ut in dc.Utakmicas
                            join ekip in dc.Ekipas
                            on ut.IDEkipeDomacina equals ekip.ID
                            join ek in dc.Ekipas
                            on ut.IDEkipeGosta equals ek.ID
                            select new { ut.ID, ut.IDEkipeDomacina, ut.IDEkipeGosta, Domacin = ekip.Naziv, Gost = ek.Naziv, ut.PocetakUtakmice, ut.KrajUtakmice, minut = trenutnoVreme.Subtract(ut.PocetakUtakmice).TotalMinutes }; 



            string minuti;
            foreach (var tekma in utakmice)
            {
                if (tekma.minut < 0)
                {
                    minuti = "Nije pocela";
                }
                else if (tekma.minut < 60 && tekma.minut > 45)
                {
                    minuti = "poluvreme";
                }
                else if (tekma.minut >= 60)
                {
                    if (tekma.minut > 105)
                    {
                        minuti = "Utakmica je zavrsena!";
                    }
                    else
                    {
                        double min = tekma.minut - 15;
                        minuti = "Igra se " + min + ". minut";
                    }

                }
                else
                {
                    double min = tekma.minut;
                    minuti = "Igra se " + min + ". minut";
                }


                if (minuti != "Utakmica je zavrsena!")
                {
                    var nova = new { Domacin = tekma.Domacin, Gost = tekma.Gost, minuti = minuti };
                    lstvTekme.Items.Add(nova);
                    
                } 
            }
        }

        private void MenuItem_Click(object sender, RoutedEventArgs e)
        {
            ZavrseneWindow zw = new ZavrseneWindow(this.dc);
            zw.Show();
        }

        private void MenuItem_Click_1(object sender, RoutedEventArgs e)
        {
            this.Close();
        }
    }
}
