﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace III_popravni
{
    /// <summary>
    /// Interaction logic for ZavrseneWindow.xaml
    /// </summary>
    public partial class ZavrseneWindow : Window
    {
        private RezultatiDataContext dc;

        public ZavrseneWindow()
        {
            InitializeComponent();
        }

        public ZavrseneWindow(RezultatiDataContext dc)
        {
            // TODO: Complete member initialization
            this.dc = dc;
            Listaj();
        }

        private void Listaj()
        {
            DateTime trenutnoVreme;
            trenutnoVreme = DateTime.Now;

            var utakmice = from ut in dc.Utakmicas
                           join e in dc.Ekipas
                           on ut.IDEkipeDomacina equals e.ID
                           join ek in dc.Ekipas
                           on ut.IDEkipeGosta equals ek.ID
                           select new { ut.ID, ut.IDEkipeDomacina, ut.IDEkipeGosta, Domacin = e.Naziv, Gost = ek.Naziv, ut.PocetakUtakmice, ut.KrajUtakmice, minut = trenutnoVreme.Subtract(ut.PocetakUtakmice).TotalMinutes };




            string minuti;
            foreach (var tekma in utakmice)
            {
                if (tekma.minut < 0)
                {
                    minuti = "Nije pocela";
                }
                else if (tekma.minut < 60 && tekma.minut > 45)
                {
                    minuti = "poluvreme";
                }
                else if (tekma.minut >= 60)
                {
                    if (tekma.minut > 105)
                    {
                        minuti = "Utakmica je zavrsena!";
                    }
                    else
                    {
                        double min = tekma.minut - 15;
                        minuti = "Igra se " + min + ". minut";
                    }

                }
                else
                {
                    double min = tekma.minut;
                    minuti = "Igra se " + min + ". minut";
                }

                if (minuti == "Utakmica je zavrsena!")
                {
                    var nova1 = new { Domacin = tekma.Domacin, Gost = tekma.Gost };
                    lstvZavrsene.Items.Add(nova1);
                }
            }
        }
    }
}
