﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Treci
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        FudbalDataContext dc;
        public MainWindow()
        {
            InitializeComponent();
            dc = new FudbalDataContext();
            
            PopuniListView();
            listView1.SelectedValuePath = "IDUtakmice";
        }

        private void PopuniListView()
        {
            listView1.ItemsSource = null;
            DateTime t = DateTime.Now;
        //    double d = (t.Subtract(t)).TotalMinutes;
            var upit = (from s in dc.Utakmicas
                        join e1 in dc.Ekipas on s.IDEkipeDomacina equals e1.ID
                        join e2 in dc.Ekipas on s.IDEkipeGosta equals e2.ID
                        where s.KrajUtakmice > t
                        select new { Domacin = e1.Naziv, Gost = e2.Naziv, Rezultat = OdrediRezultat(s.ID,s.IDEkipeDomacina,s.IDEkipeGosta), Minut = OdrediVreme(t, s.PocetakUtakmice),
                                     PocetakUtakmice = s.PocetakUtakmice, IDUtakmice = s.ID
                        });  // OrderBy(PocetakUtakmice);
            listView1.ItemsSource = upit;

        }

        private string OdrediRezultat(int IDtekme, int IDDomacina, int IDGosta)
        {
            int goloviDomacina = 0, goloviGosta = 0;
            var upitD = (from g in dc.Gols
                        where (g.IDUtakmice == IDtekme && g.IDEkipe == IDDomacina)
                        select g).Count();
            var upitG = (from g in dc.Gols
                         where (g.IDUtakmice == IDtekme && g.IDEkipe == IDGosta)
                         select g).Count();
            goloviDomacina = upitD;
            goloviGosta = upitG;
            return goloviDomacina.ToString() + ":" + goloviGosta.ToString();
        }

        private string OdrediVreme(DateTime sadasnjeVreme, DateTime vremePocetkaUtakmice)
        {
            string s = " ";
            int minut = 0;
            double d = (sadasnjeVreme.Subtract(vremePocetkaUtakmice)).TotalMinutes;
            if (d <= 0) s = "mec nije poceo";
            else if (d < 60 && d>=45)  s = "poluvreme";
            else if (d > 60)
            {
                minut = (int)d - 15;
                s = minut.ToString();
            }
            else if (d > 0 && d < 45)
            {
                minut = (int)d;
                s = minut.ToString();
            }
            return s;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            PopuniListView();
        }

        private void listView1_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            UnosNovogPogotkaWindow unpw = new UnosNovogPogotkaWindow(dc, listView1);
            unpw.Title = "Unos novog pogotka";
            unpw.Show();
        }
    }
}
