﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace Treci
{
    /// <summary>
    /// Interaction logic for UnosNovogPogotkaWindow.xaml
    /// </summary>
    public partial class UnosNovogPogotkaWindow : Window
    {
        FudbalDataContext dc;
        string timG;
        string igracG;
        int IDTekme;
        
        public UnosNovogPogotkaWindow()
        {
            InitializeComponent();
        }

        public UnosNovogPogotkaWindow(FudbalDataContext fdc, ListView ls):this()
        {
            dc = fdc;
            PopuniKomboTim(ls);
            
        }
        private void PopuniKomboTim(ListView ls)
        {
            IDTekme = (int)ls.SelectedValue;
            //MessageBox.Show(IDTekme.ToString());
            var utakmica = (from s in dc.Utakmicas
                            where s.ID == IDTekme
                            select s).FirstOrDefault();
            //MessageBox.Show(utakmica.ID.ToString());
            var upit = (from s in dc.Utakmicas
                        join e1 in dc.Ekipas on s.IDEkipeDomacina equals e1.ID
                        join e2 in dc.Ekipas on s.IDEkipeGosta equals e2.ID
                        where s.ID == IDTekme
                        select new { nazivDomacegTima = e1.Naziv, nazivGostujucegTima = e2.Naziv }).FirstOrDefault();

            //MessageBox.Show(upit.nazivDomacegTima.ToString() + " " + upit.nazivGostujucegTima.ToString());
            string domacin = upit.nazivDomacegTima.ToString();
            string gost = upit.nazivGostujucegTima.ToString();
            cmbTimovi.Items.Add(domacin);
            cmbTimovi.Items.Add(gost);
            cmbTimovi.SelectedIndex = 0;
            PopuniKomboIgrac();
        }

        private void PopuniKomboIgrac()
        {
            string tim = cmbTimovi.SelectedItem.ToString();
            var upit = from e in dc.Ekipas
                       join i in dc.Igracs on e.ID equals i.IDEkipe
                       where e.Naziv == tim
                       select i.Ime;
            cmbIgraci.ItemsSource = upit;
            cmbIgraci.SelectedIndex = 0;
            string igrac = cmbIgraci.SelectedItem.ToString();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            string timG = cmbTimovi.SelectedItem.ToString();
            string igracG = cmbIgraci.SelectedItem.ToString();
            Gol noviGol = new Gol();
            //MessageBox.Show(timG);
            var idtim = (from s in dc.Ekipas
                        where s.Naziv.Equals(timG)
                        select s).FirstOrDefault();
            int idTima = idtim.ID;
            var idigrac = (from s in dc.Igracs
                         where s.Ime.Equals(igracG)
                         select s).FirstOrDefault();
            int idIgraca = idigrac.ID;
            noviGol.IDEkipe = idTima;
            noviGol.IDIgraca = idIgraca;
            noviGol.IDUtakmice = IDTekme;
            dc.Gols.InsertOnSubmit(noviGol);
            dc.SubmitChanges();
            this.Close();
        }
    }
}
