﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    class Putovanje : IPopust
    {
        private string pocetnaDestinacija;
        private string krajnjaDestinacija;
        protected List<Aranzman> listaAranzmana;

        public Putovanje(string pocetnaDestinacija, string krajnjaDestinacija)
        {
            this.pocetnaDestinacija = pocetnaDestinacija;
            this.krajnjaDestinacija = krajnjaDestinacija;
        }

        public void dodajAranzman(List<Aranzman> aranzmani)
        {
            Aranzman p, k;
            p = aranzmani.FirstOrDefault();
            k = aranzmani.LastOrDefault();

            if (p.PocetnaDestinacija != pocetnaDestinacija)
            {
                GreskaPutovanja g = new GreskaPutovanja(p, "destinacije se ne poklapaju");
                return;
            }

            if (k.KrajnjaDestinacija != krajnjaDestinacija)
            {
                GreskaPutovanja g = new GreskaPutovanja(k, "destinacije se ne poklapaju");
                return;
            }

            listaAranzmana = new List<Aranzman>(aranzmani);
        }

        public double CenaPutovanja()
        {
            double suma = 0;

            foreach (Aranzman item in listaAranzmana)
            {
                suma += item.cenaAranzmana();
            }

            return suma;
        }

        public double Popust
        {
            get { throw new NotImplementedException(); }
        }

        public override string ToString()
        {
            string s = "Putovanje: " + pocetnaDestinacija + " - " + krajnjaDestinacija + "\n";
            
            if (listaAranzmana != null)
            foreach (Aranzman item in listaAranzmana)
            {
                
                    s += item.ToString() + "\n";
            }
            return s;
        }
    }
}
