﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace I
{
    public class Aranzman : IPopust
    {
        private string pocetnaDestinacija;
        private string krajnjaDestinacija;
        private bool lastMinute;
        private int brojNocenja;
        private double cenaNocenja;
        protected List<Karta> karte;
        public string PocetnaDestinacija
        {
            get { return pocetnaDestinacija; }
        }

        public string KrajnjaDestinacija
        {
            get { return krajnjaDestinacija; }
        }

        public Aranzman(string pocetnaDestinacija, string krajnjaDestinacija, int brojNocenja, double cenaNocenja, bool lastMinute)
        {
            this.pocetnaDestinacija = pocetnaDestinacija;
            this.krajnjaDestinacija = krajnjaDestinacija;
            this.lastMinute = lastMinute;
            this.brojNocenja = brojNocenja;
            this.cenaNocenja = cenaNocenja;
            karte = new List<Karta>();
        }
        public void dodajKarte(List<Karta> karte)
        {
            if (!(pocetnaDestinacija.Equals(karte[0]))) throw new GreskaAranzmana(karte[0], "Nije ista destinacija!");
            this.karte = karte;
        }

        public double CenaAranzmana
        {
            get
            {
                double suma = 0;

                suma += cenaNocenja * brojNocenja;
                    foreach (Karta k in karte)
                    {
                         suma += k.dajCenuKarte();
                    }
                
                   
                return suma;
            }
        }

        public override string ToString()
        {
            string s = "";
            s += "Aranzman: " + pocetnaDestinacija + "-" + krajnjaDestinacija;
            foreach (Karta k in karte)
            {
                s += k.ToString();
            }
            return s;

        }


        public double Vrednost
        {
            get 
            {
                double suma=0;
                foreach (Karta k in karte)
                {
                    if (k is IPopust) suma += (k as IPopust).Vrednost;
                }
                if (lastMinute == true) suma += cenaNocenja * brojNocenja * 0.3;
                return suma;
            }
        }
    }
}
