﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TreciPopravni
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        DataClasses1DataContext dc;
        public MainWindow()
        {
            InitializeComponent();
            dc = new DataClasses1DataContext();
            PopuniRezultate();
        }

        private void PopuniRezultate()
        {
            var upit = from ut in dc.Utakmicas
                       join ek in dc.Ekipas
                       on ut.IDEkipeDomacina equals ek.ID
                       join ek2 in dc.Ekipas
                       on ut.IDEkipeGosta equals ek2.ID
                       where ut.PocetakUtakmice.Day >= DateTime.Now.Day && ut.PocetakUtakmice.Hour >= DateTime.Now.Hour
                       select new { Domacin = ek.Naziv, Gost = ek2.Naziv, Rezultat = KojiJeRez(ut.ID, ut.PocetakUtakmice, ut.KrajUtakmice,ek.ID, ek2.ID), Minut = OdrediMinut(ut.PocetakUtakmice, ut.KrajUtakmice) };



            listaRezultata.ItemsSource = upit;
        }

        private string KojiJeRez(int idUtakmice, DateTime dateTime1, DateTime dateTime2, int idEkipe1, int idEkipe2)
        {
            var prikaz = (from gol in dc.Gols
                          where gol.IDUtakmice == idUtakmice && gol.IDEkipe == idEkipe1 && OdrediMinut(dateTime1, dateTime2) != "Mec nije poceo"
                          select gol.VremeGola).Count();

            int ek1 = prikaz;
            var prikaz2 = (from gol in dc.Gols
                          where gol.IDUtakmice == idUtakmice && gol.IDEkipe == idEkipe2 && OdrediMinut(dateTime1, dateTime2) != "Mec nije poceo"
                          select gol.VremeGola).Count();

            int ek2 = prikaz2;

            return ek1+":"+ek2;
        }


        private string OdrediMinut(DateTime dateTime1, DateTime dateTime2)
        {
            double pom;
            //string vrati = "";



            if (DateTime.Now.Subtract(dateTime1).TotalMinutes < 0)
            {
                return "Mec nije poceo";

            }
            if (DateTime.Now.Subtract(dateTime1).TotalMinutes > 45 && dateTime1.Subtract(DateTime.Now).TotalMinutes < 60)
            {
                return "poluvreme";              
            }

            if (DateTime.Now.Subtract(dateTime1).TotalMinutes >= 60)
            {
                pom = dateTime1.Subtract(DateTime.Now).TotalMinutes - 15;
                int pomdva = Convert.ToInt32(pom);
                return pomdva + "'";
            }
            else 
            {
                int pomdva = Convert.ToInt32(DateTime.Now.Subtract(dateTime1).TotalMinutes);
                return pomdva + "'";
            }
            
        }


        private void btnOsvezi_Click(object sender, RoutedEventArgs e)
        {
            PopuniRezultate();
        }
    }
}
