﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PopravniII
{
    public class BinarnoStablo<T> where T : IComparable<T>
    {
        Cvor<T> glava=null;
        Cvor<T> pom, preth;
        List<Cvor<T>> lista = new List<Cvor<T>>();
        public void dodajVrednost(T t)
        {
            if (glava == null)
                glava = new Cvor<T>(t);
            else
            {
                pom = glava;
                preth = null;
                while (pom != null)
                {
                    preth = pom;
                    if (-1 == pom.Vrednost.CompareTo(t))
                        pom = pom.levo;
                    else
                        pom = pom.desno;
                }
                if (-1 == preth.Vrednost.CompareTo(t))
                    preth.levo = new Cvor<T>(t);
                else
                    preth.desno = new Cvor<T>(t);
            }
        }

        private List<Cvor<T>> UzmiListu(Cvor<T> cvor)
        {
            if (cvor != null)
            {
                if (cvor.levo != null)
                    UzmiListu(cvor.levo);
                lista.Add(cvor);
                if (cvor.desno != null)
                    UzmiListu(cvor.desno);
            }
            return lista;
        }


        public IEnumerable<T> VratiEnumeratorPremaSelekciji(Selektuj<T> selektor)
        {
            if (glava != null)
            {
                lista.Clear();
                UzmiListu(glava);
                foreach (Cvor<T> item in lista)
                {
                    if(selektor(item.Vrednost))
                        yield return item.Vrednost;
                }
            }
        }

        public Cvor<T> this[int index]
        {
            get
            {
                int i = 0;
                lista.Clear();
                UzmiListu(glava);
                foreach (var item in lista)
                {
                    if (i == index)
                        return item;
                    else
                        i++;
                }
                return null;
            }
        }

    }
}
