﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace PopravniII
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public BinarnoStablo<Student> stablo;
        public List<Student> lista;
        public MainWindow()
        {
            InitializeComponent();
            stablo = new BinarnoStablo<Student>();
            lista = new List<Student>();
            Student s1, s2, s3, s4, s5, s6;
            lista.Add(s4 = new Student(2, 2011, "Mika mikic", new DateTime(1990, 01, 03)));
            s4.BrojPoena = 7;
            lista.Add(s5 = new Student(1, 2010, "Jovan Jovanovic", new DateTime(1992, 01, 01)));
            s5.BrojPoena = 6;
            lista.Add(s6 = new Student(1, 2010, "Milan Milanovic", new DateTime(1991, 01, 01)));
            s6.BrojPoena = 3;
            lista.Add(s1 = new Student(1, 2012, "Pera Peric", new DateTime(1991, 01, 01)));
            s1.BrojPoena = 15;
            lista.Add(s2 = new Student(1, 2010, "Ivan Ivanovic", new DateTime(1992, 01, 01)));
            s2.BrojPoena = 8;
            lista.Add(s3 = new Student(3, 2012, "Marko Markovic", new DateTime(1991, 01, 01)));
            s3.BrojPoena = 7.5;
            
            foreach (var item in lista)
            {
                stablo.dodajVrednost(item);
            }
            osvezilistu();
        }

        private void dodajbtn_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                if(indextxt.Text!="" && imetxt.Text!=""&&godinatxt.Text!="" && datumtxt.SelectedDate!=null&&poenitxt.Text!="")
                {
                    Student s = new Student(int.Parse(indextxt.Text), int.Parse(godinatxt.Text), imetxt.Text, (DateTime)datumtxt.SelectedDate);
                    s.BrojPoena = double.Parse(poenitxt.Text);
                    
                    if (!sadrzi(s))
                    {
                        stablo.dodajVrednost(s);
                        lista.Add(s);
                        osvezilistu();
                    }
                    else
                        MessageBox.Show("Vec postoji student sa odabranim brojem indeksa i godinom upisa!");
                }
            }
            catch (Exception)
            {
                MessageBox.Show("Niste pravilno uneli podatke!");
                indextxt.Text = imetxt.Text = godinatxt.Text = poenitxt.Text = "";
                datumtxt.SelectedDate = null;
            }
        }

        private bool sadrzi(Student s)
        {
            foreach (var item in lista)
            {
                if (item.Index == s.Index && item.GodinaUpisa == s.GodinaUpisa)
                    return true;
            }
            return false;
        }

        private void osvezilistu()
        {
            listadodatih.Items.Clear();
            foreach (var item in stablo.VratiEnumeratorPremaSelekciji(x=>true))
	        {
		        listadodatih.Items.Add(item);
	        }
        }

        private void kriterijumbtn_Click(object sender, RoutedEventArgs e)
        {
            pretragalist.Items.Clear();
            if (kriterijumcombo.SelectedIndex != -1)
            {
                try
                {
                    double max = double.Parse(maxpoentxt.Text) / 2;
                    if (kriterijumcombo.SelectedIndex == 0)
                    {
                        foreach (var item in stablo.VratiEnumeratorPremaSelekciji(x => x.BrojPoena >= max))
                        {
                            pretragalist.Items.Add(item);
                        }
                    }
                    else
                    {
                        List<Student> l = new List<Student>();
                        l.Clear();
                        foreach (var item in stablo.VratiEnumeratorPremaSelekciji(x => x.BrojPoena < max && (x.DatumRodjenja.Year == 1991 || x.DatumRodjenja.Year == 1992)))
                        {
                            l.Add(item);
                        }
                        l.Reverse();
                        foreach (var item in l)
	                  {
		                    pretragalist.Items.Add(item);
	                    }
                    
                    }
                }
                catch (Exception)
                {
                    MessageBox.Show("Unesite ispravan broj za maksimalan broj bodova!");
                }
            }
        }

        private void rednibrojbtn_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                if (rednibrojtxt.Text != "")
                    rednibrojlbl.Content = stablo[int.Parse(rednibrojtxt.Text)-1].Vrednost;
                else
                    MessageBox.Show("Unesite redni broj studenta!");
            }
            catch (Exception)
            {
                MessageBox.Show("Niste uneli ispravan redni broj. Unesite ponovo!");
                rednibrojtxt.Text = "";
            }
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            osvezilistu();
        }
    }
}
