﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PopravniII
{
    public class Student: IComparable<Student>, IEquatable<Student>
    {
        private int index;

        public int Index
        {
            get { return index; }
        }
        private int godinaUpisa;

        public int GodinaUpisa
        {
            get { return godinaUpisa; }
        }
        private string imeIPrezime;

        public string ImeIPrezime
        {
            get { return imeIPrezime; }
        }
        private DateTime datumRodjenja;

        public DateTime DatumRodjenja
        {
            get { return datumRodjenja; }
        }
        private double brojPoena;

        public double BrojPoena
        {
            get { return brojPoena; }
            set { brojPoena = value; }
        }

        public Student(int index, int godina, string ime, DateTime dob)
        {
            this.index = index;
            godinaUpisa = godina;
            imeIPrezime = ime;
            datumRodjenja = dob;
        }

        public int CompareTo(Student other)
        {
            if (this.Equals(other) == true)
                return 0;
            else
            if (this.BrojPoena < other.BrojPoena)
                return -1;
            else
                return 1;
        }

        public bool Equals(Student other)
        {
            if (this.BrojPoena == other.BrojPoena)
                return true;
            else
                return false;
        }

        public override string ToString()
        {
            return ImeIPrezime + ": " + DatumRodjenja.Date.ToShortDateString() + ", " + Index + "/" + GodinaUpisa + ", " + BrojPoena;
        }
    }
}
